glibmm: Gio::CharsetConverter Class Reference

glibmm 2.76.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::CharsetConverter Class Reference

CharsetConverter - Convert between charsets. More...

`#include <giomm/charsetconverter.h>`

Inheritance diagram for Gio::CharsetConverter:
[legend]

## Public Member Functions
| CharsetConverter (CharsetConverter && src) noexcept
CharsetConverter & | operator= (CharsetConverter && src) noexcept
| ~CharsetConverter () noexcept override
GCharsetConverter * | gobj ()
| Provides access to the underlying C GObject.
const GCharsetConverter * | gobj () const
| Provides access to the underlying C GObject.
GCharsetConverter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_use_fallback (bool use_fallback)
| Sets the CharsetConverter::property_use_fallback() property.
bool | get_use_fallback () const
| Gets the CharsetConverter::property_use_fallback() property.
guint | get_num_fallbacks () const
| Gets the number of fallbacks that converter has applied so far.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_from_charset () const
| The character encoding to convert from.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_to_charset () const
| The character encoding to convert to.
Glib::PropertyProxy< bool > | property_use_fallback ()
| Use fallback (of form \<hexval>) for invalid bytes.
Glib::PropertyProxy_ReadOnly< bool > | property_use_fallback () const
| Use fallback (of form \<hexval>) for invalid bytes.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from Gio::Converter
| Converter (Converter && src) noexcept
Converter & | operator= (Converter && src) noexcept
| ~Converter () noexcept override
GConverter * | gobj ()
| Provides access to the underlying C GObject.
const GConverter * | gobj () const
| Provides access to the underlying C GObject.
Result | convert (const void * inbuf, gsize inbuf_size, void * outbuf, gsize outbuf_size, Flags flags, gsize & bytes_read, gsize & bytes_written)
| This is the main operation used when converting data.
void | reset ()
| Resets all internal state in the converter, making it behave as if it was just created.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes.
| Interface (GObject * castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gio::Initable
| Initable (Initable && src) noexcept
Initable & | operator= (Initable && src) noexcept
| ~Initable () noexcept override
GInitable * | gobj ()
| Provides access to the underlying C GObject.
const GInitable * | gobj () const
| Provides access to the underlying C GObject.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< CharsetConverter > | create (const Glib::ustring & to_charset, const Glib::ustring & from_charset)
| Creates a new CharsetConverter.
Static Public Member Functions inherited from Gio::Converter
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::Initable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| CharsetConverter (const Glib::ustring & to_charset, const Glib::ustring & from_charset)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)
Protected Member Functions inherited from Gio::Converter
| Converter ()
| You should derive from this class to use it.
virtual Result | convert_vfunc (const void * inbuf, gsize inbuf_size, void * outbuf, gsize outbuf_size, Flags flags, gsize & bytes_read, gsize & bytes_written)
virtual void | reset_vfunc ()
Protected Member Functions inherited from Gio::Initable
| Initable ()
| You should derive from this class to use it.
void | init (const Glib::RefPtr< Cancellable > & cancellable)
| Initializes the object implementing the interface.
void | init ()
| A init() convenience overload.
virtual bool | init_vfunc (const Glib::RefPtr< Cancellable > & cancellable, GError ** error)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::CharsetConverter > | wrap (GCharsetConverter * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)
Related Functions inherited from Gio::Converter
Glib::RefPtr< Gio::Converter > | wrap (GConverter * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::Initable
Glib::RefPtr< Gio::Initable > | wrap (GInitable * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from Gio::Converter
enum class | Result { Result::ERROR , Result::CONVERTED , Result::FINISHED , Result::FLUSHED }
| Results returned from g_converter_convert(). More...
enum class | Flags { Flags::NO_FLAGS = 0x0 , Flags::INPUT_AT_END = (1 << 0) , Flags::FLUSH = (1 << 1) }
| Flags used when calling a g_converter_convert(). More...

## Detailed Description

CharsetConverter - Convert between charsets.

CharsetConverter is an implementation of Converter based on GIConv.

Since glibmm 2.34:

## Constructor & Destructor Documentation

## ◆ CharsetConverter() [1/2]

Gio::CharsetConverter::CharsetConverter | ( | CharsetConverter && | src | ) |
| noexcept

## ◆ ~CharsetConverter()

Gio::CharsetConverter::~CharsetConverter | ( |  | ) |
| overridenoexcept

## ◆ CharsetConverter() [2/2]

Gio::CharsetConverter::CharsetConverter | ( | const Glib::ustring & | to_charset,
|  | const Glib::ustring & | from_charset
| ) |  |
| explicitprotected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< CharsetConverter > Gio::CharsetConverter::create | ( | const Glib::ustring & | to_charset,
|  | const Glib::ustring & | from_charset
| ) |  |
| static

Creates a new CharsetConverter.

Since glibmm 2.24:

Parameters

  to_charset | Destination charset.
  from_charset | Source charset.

Returns
  A new CharsetConverter, or `nullptr` on error.

Exceptions

  Gio::Error |

## ◆ get_num_fallbacks()

guint Gio::CharsetConverter::get_num_fallbacks | ( |  | ) | const

Gets the number of fallbacks that converter has applied so far.

Since glibmm 2.24:

Returns
  The number of fallbacks that converter has applied.

## ◆ get_type()

static GType Gio::CharsetConverter::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_use_fallback()

bool Gio::CharsetConverter::get_use_fallback | ( |  | ) | const

Gets the CharsetConverter::property_use_fallback() property.

Since glibmm 2.24:

Returns
  `true` if fallbacks are used by converter.

## ◆ gobj() [1/2]

GCharsetConverter * Gio::CharsetConverter::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GCharsetConverter * Gio::CharsetConverter::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GCharsetConverter * Gio::CharsetConverter::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

CharsetConverter & Gio::CharsetConverter::operator= | ( | CharsetConverter && | src | ) |
| noexcept

## ◆ property_from_charset()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::CharsetConverter::property_from_charset | ( |  | ) | const

The character encoding to convert from.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_to_charset()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::CharsetConverter::property_to_charset | ( |  | ) | const

The character encoding to convert to.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_use_fallback() [1/2]

Glib::PropertyProxy< bool > Gio::CharsetConverter::property_use_fallback | ( |  | ) |

Use fallback (of form \<hexval>) for invalid bytes.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_use_fallback() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gio::CharsetConverter::property_use_fallback | ( |  | ) | const

Use fallback (of form \<hexval>) for invalid bytes.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_use_fallback()

void Gio::CharsetConverter::set_use_fallback | ( | bool | use_fallback | ) |

Sets the CharsetConverter::property_use_fallback() property.

Since glibmm 2.24:

Parameters

  use_fallback | `true` to use fallbacks.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::CharsetConverter > wrap | ( | GCharsetConverter * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.